local UPDATEPERIOD, elapsed = 0.5, 0
local LDBThreat = LibStub("LibDataBroker-1.1"):NewDataObject("LDBThreat", { icon = "Interface\\TARGETINGFRAME\\UI-TargetingFrame-Skull.blp", type = "data source", text = "" })

local Color = {green = "ff00ff00", blue = "ff00ffff", red = "ffff0000", yellow = "ffffff00", orange = "ffffa500",}

local f = CreateFrame("Frame")
f:RegisterEvent("UNIT_THREAT_SITUATION_UPDATE")
f:RegisterEvent("UNIT_THREAT_LIST_UPDATE")
f:RegisterEvent("PLAYER_TARGET_CHANGED")
f:RegisterEvent("PARTY_MEMBERS_CHANGED")

local function GetThreat(unitId, mobId)
	local _, _, _, rawthreatpct, _ = UnitDetailedThreatSituation(unitId, mobId)
	if not rawthreatpct then rawthreatpct = 0 end
	return rawthreatpct
end
	
local function GetThreatValue(unitId, mobId)
	local _, _, _, _, threatvalue = UnitDetailedThreatSituation(unitId, mobId)
	if not threatvalue then threatvalue = 0 end
	if threatvalue < 0 then threatvalue = threatvalue + 410065408 end
	return threatvalue
end

f:SetScript("OnUpdate", function(self, elap)
	elapsed = elapsed + elap
	if elapsed < UPDATEPERIOD then return end

	elapsed = 0
	LDBThreat.text = "LDB-|cffffffffThreat|r"
	local nextThreat = 0
	local partynum = GetNumPartyMembers()
	local raidnum = GetNumRaidMembers()
	if (partynum == 0 and raidnum == 0) and UnitCanAttack("player", "target") and not(UnitIsDead("target") or UnitIsFriend("player", "target") or UnitPlayerControlled("target")) -- Solo Target
	then			
		local isTanking,status,_,rawthreatpct, threatvalue = UnitDetailedThreatSituation("player", "target")	
		nextThreat = max(nextThreat, GetThreat("pet", "target"))
		if status == 0
		then
			LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.green, rawthreatpct )
			if rawthreatpct > 79 and rawthreatpct < 100
			then
				LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.yellow, rawthreatpct )
			end
			if threatvalue < 0
			then
				if UnitExists("targettarget") and not UnitCanAttack("player", "targettarget")
				then
					tempthreat = floor((GetThreatValue("player", "target") / GetThreatValue("targettarget", "target")) * 100)
					LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.blue, tempthreat )
				end
			end
		else if status == 1
		then
			LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.orange, rawthreatpct )
			if threatvalue < 0
			then
				if UnitExists("targettarget") and not UnitCanAttack("player", "targettarget")
				then
					tempthreat = floor((GetThreatValue("player", "target") / GetThreatValue("targettarget", "target")) * 100)
					LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.blue, tempthreat )
				end
			end
		else if status == 2
		then
			threatdiff = (100 - nextThreat)
			LDBThreat.text = string.format("|c%sWEAK AGGRO: %d %% Lead.|r", Color.yellow, threatdiff )
			if nextThreat == 0
			then
				LDBThreat.text = string.format("|c%s** WEAK AGGRO! **|r", Color.yellow )
				if threatvalue < 0
				then
					LDBThreat.text = string.format("|c%s** WEAK AGGRO! **|r", Color.blue )
				end
			end	
		else if status == 3
		then
			threatdiff = (100 - nextThreat)
			LDBThreat.text = string.format("|c%sAGGRO: %d %% Lead.|r", Color.red, threatdiff )
			if nextThreat == 0
			then
				LDBThreat.text = string.format("|c%s** AGGRO! **|r", Color.red )
				if threatvalue < 0
				then
					LDBThreat.text = string.format("|c%s** AGGRO! **|r", Color.blue )
				end
			end
		end
		end
		end
		end
	end
	if (partynum == 0 and raidnum == 0) and UnitCanAttack("player", "targettarget") and not (UnitCanAttack("player", "target") or UnitIsDead("targettarget") or UnitIsFriend("player", "targettarget") or UnitPlayerControlled("targettarget")) -- Solo Target of Target
	then
		local _,status,_,rawthreatpct, threatvalue = UnitDetailedThreatSituation("player", "targettarget")				
		nextThreat = max(nextThreat, GetThreat("pet", "targettarget"))		
		if status == 0
		then
			LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.green, rawthreatpct )
			if rawthreatpct > 79 and rawthreatpct < 100
			then
				LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.yellow, rawthreatpct )
			end
			if threatvalue < 0
			then
				tempthreat = floor((GetThreatValue("player", "targettarget") / GetThreatValue("targettargettarget", "targettarget")) * 100)
				LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.blue, tempthreat )
			end
		else if status == 1
		then
			LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.orange, rawthreatpct )
			if threatvalue < 0
			then
				tempthreat = floor((GetThreatValue("player", "targettarget") / GetThreatValue("targettargettarget", "targettarget")) * 100)
				LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.blue, tempthreat )
			end
		else if status == 2
		then
			threatdiff = (100 - nextThreat)
			LDBThreat.text = string.format("|c%sWEAK AGGRO: %d %% Lead.|r", Color.yellow, threatdiff )
			if threatvalue < 0
			then
				LDBThreat.text = string.format("|c%sWEAK AGGRO: %d %% Lead.|r", Color.blue, threatdiff )
			end
			if nextThreat == 0
			then
				LDBThreat.text = string.format("|c%s** WEAK AGGRO! **|r", Color.yellow )
				if threatvalue < 0
				then
					LDBThreat.text = string.format("|c%s** WEAK AGGRO! **|r", Color.blue )
				end
			end	
		else if status == 3
		then
			threatdiff = (100 - nextThreat)
			LDBThreat.text = string.format("|c%sAGGRO: %d %% Lead.|r", Color.red, threatdiff )
			if nextThreat == 0
			then
				LDBThreat.text = string.format("|c%s** AGGRO! **|r", Color.red )
				if threatvalue < 0
				then
					LDBThreat.text = string.format("|c%s** AGGRO! **|r", Color.blue )
				end
			end
		end
		end
		end
		end
	end
	if (raidnum > 0) and UnitCanAttack("player", "target") and not (UnitIsDead("target") or UnitIsFriend("player", "target") or UnitPlayerControlled("target")) --Raid Target
	then 
		local isTanking,status,_,rawthreatpct, threatvalue = UnitDetailedThreatSituation("player", "target")
		for i = 1, (raidnum -1) do
			nextThreat = max(nextThreat, GetThreat("raid"..i, "target")) 	
			nextThreat = max(nextThreat, GetThreat("raidpet"..i, "target")) 	
			nextThreat = max(nextThreat, GetThreat("pet", "target"))
		if status == 0
		then
			LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.green, rawthreatpct )
			if rawthreatpct > 79 and rawthreatpct < 100
			then
				LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.yellow, rawthreatpct )
			end
			if threatvalue < 0
			then
				if UnitExists("targettarget") and not UnitCanAttack("player", "targettarget")
				then
					tempthreat = floor((GetThreatValue("player", "target") / GetThreatValue("targettarget", "target")) * 100)
					LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.blue, tempthreat )
				end
			end
		else if status == 1
		then
			LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.orange, rawthreatpct )
			if threatvalue < 0
			then
				if UnitExists("targettarget") and not UnitCanAttack("player", "targettarget")
				then
					tempthreat = floor((GetThreatValue("player", "target") / GetThreatValue("targettarget", "target")) * 100)
					LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.blue, tempthreat )
				end
			end
		else if status == 2
		then
			threatdiff = (100 - nextThreat)
			LDBThreat.text = string.format("|c%sWEAK AGGRO: %d %% Lead.|r", Color.yellow, threatdiff )
			if nextThreat == 0
			then
				LDBThreat.text = string.format("|c%s** WEAK AGGRO! **|r", Color.yellow )
				if threatvalue < 0
				then
					LDBThreat.text = string.format("|c%s** WEAK AGGRO! **|r", Color.blue )
				end
			end	
		else if status == 3
		then
			threatdiff = (100 - nextThreat)
			LDBThreat.text = string.format("|c%sAGGRO: %d %% Lead.|r", Color.red, threatdiff )
			if nextThreat == 0
			then
				LDBThreat.text = string.format("|c%s** AGGRO! **|r", Color.red )
				if threatvalue < 0
				then
					LDBThreat.text = string.format("|c%s** AGGRO! **|r", Color.blue )
				end
			end
		end
		end 
		end
		end
		end
	end
	if (raidnum > 0) and UnitCanAttack("player", "targettarget") and not (UnitCanAttack("player", "target") or UnitIsDead("targettarget") or UnitIsFriend("player", "targettarget") or UnitPlayerControlled("targettarget")) --Raid Target of Target
	then
		local _,status,_,rawthreatpct, threatvalue = UnitDetailedThreatSituation("player", "targettarget")				
		for i = 1, (raidnum -1) do
			nextThreat = max(nextThreat, GetThreat("raid"..i, "targettarget")) 	
			nextThreat = max(nextThreat, GetThreat("raidpet"..i, "targettarget"))	
			nextThreat = max(nextThreat, GetThreat("pet", "targettarget"))
		if status == 0
		then
			LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.green, rawthreatpct )
			if rawthreatpct > 79 and rawthreatpct < 100
			then
				LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.yellow, rawthreatpct )
			end
			if threatvalue < 0
			then
				tempthreat = floor((GetThreatValue("player", "targettarget") / GetThreatValue("targettargettarget", "targettarget")) * 100)
				LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.blue, tempthreat )
			end
		else if status == 1
		then
			LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.orange, rawthreatpct )
			if threatvalue < 0
			then
				tempthreat = floor((GetThreatValue("player", "targettarget") / GetThreatValue("targettargettarget", "targettarget")) * 100)
				LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.blue, tempthreat )
			end
		else if status == 2
		then
			threatdiff = (100 - nextThreat)
			LDBThreat.text = string.format("|c%sWEAK AGGRO: %d %% Lead.|r", Color.yellow, threatdiff )
			if threatvalue < 0
			then
				LDBThreat.text = string.format("|c%sWEAK AGGRO: %d %% Lead.|r", Color.blue, threatdiff )
			end
			if nextThreat == 0
			then
				LDBThreat.text = string.format("|c%s** WEAK AGGRO! **|r", Color.yellow )
				if threatvalue < 0
				then
					LDBThreat.text = string.format("|c%s** WEAK AGGRO! **|r", Color.blue )
				end
			end	
		else if status == 3
		then
			threatdiff = (100 - nextThreat)
			LDBThreat.text = string.format("|c%sAGGRO: %d %% Lead.|r", Color.red, threatdiff )
			if nextThreat == 0
			then
				LDBThreat.text = string.format("|c%s** AGGRO! **|r", Color.red )
				if threatvalue < 0
				then
					LDBThreat.text = string.format("|c%s** AGGRO! **|r", Color.blue )
				end
			end
		end
		end
		end
		end
		end
	end
	if (partynum > 0) and UnitCanAttack("player", "target") and not (UnitIsDead("target") or UnitIsFriend("player", "target") or UnitPlayerControlled("target")) -- Party Target
	then 
		local isTanking,status,_,rawthreatpct, threatvalue = UnitDetailedThreatSituation("player", "target")	
		for i = 1, partynum do
			nextThreat = max(nextThreat, GetThreat("party"..i, "target")) 	
			nextThreat = max(nextThreat, GetThreat("partypet"..i, "target"))	
			nextThreat = max(nextThreat, GetThreat("pet", "target"))
		if status == 0
		then
			LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.green, rawthreatpct )
			if rawthreatpct > 79 and rawthreatpct < 100
			then
				LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.yellow, rawthreatpct )
			end
			if threatvalue < 0
			then
				if UnitExists("targettarget") and not UnitCanAttack("player", "targettarget")
				then
					tempthreat = floor((GetThreatValue("player", "target") / GetThreatValue("targettarget", "target")) * 100)
					LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.blue, tempthreat )
				end
			end
		else if status == 1
		then
			LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.orange, rawthreatpct )
			if threatvalue < 0
			then
				if UnitExists("targettarget") and not UnitCanAttack("player", "targettarget")
				then
					tempthreat = floor((GetThreatValue("player", "target") / GetThreatValue("targettarget", "target")) * 100)
					LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.blue, tempthreat )
				end
			end
		else if status == 2
		then
			threatdiff = (100 - nextThreat)
			LDBThreat.text = string.format("|c%sWEAK AGGRO: %d %% Lead.|r", Color.yellow, threatdiff )
			if nextThreat == 0
			then
				LDBThreat.text = string.format("|c%s** WEAK AGGRO! **|r", Color.yellow )
				if threatvalue < 0
				then
					LDBThreat.text = string.format("|c%s** WEAK AGGRO! **|r", Color.blue )
				end
			end	
		else if status == 3
		then
			threatdiff = (100 - nextThreat)
			LDBThreat.text = string.format("|c%sAGGRO: %d %% Lead.|r", Color.red, threatdiff )
			if nextThreat == 0
			then
				LDBThreat.text = string.format("|c%s** AGGRO! **|r", Color.red )
				if threatvalue < 0
				then
					LDBThreat.text = string.format("|c%s** AGGRO! **|r", Color.blue )
				end
			end
		end
		end
		end
		end
		end
	end
	if (partynum > 0) and UnitCanAttack("player", "targettarget") and not (UnitCanAttack("player", "target") or UnitIsDead("targettarget") or UnitIsFriend("player", "targettarget") or UnitPlayerControlled("targettarget")) --Party Target of Target
	then
		local _,status,_,rawthreatpct, threatvalue = UnitDetailedThreatSituation("player", "targettarget")				
		for i = 1, partynum do
			nextThreat = max(nextThreat, GetThreat("party"..i, "targettarget")) 	
			nextThreat = max(nextThreat, GetThreat("partypet"..i, "targettarget"))	
			nextThreat = max(nextThreat, GetThreat("pet", "targettarget"))
		if status == 0
		then
			LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.green, rawthreatpct )
			if rawthreatpct > 79 and rawthreatpct < 100
			then
				LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.yellow, rawthreatpct )
			end
			if threatvalue < 0
			then
				tempthreat = floor((GetThreatValue("player", "targettarget") / GetThreatValue("targettargettarget", "targettarget")) * 100)
				LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.blue, tempthreat )
			end
		else if status == 1
		then
			LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.orange, rawthreatpct )
			if threatvalue < 0
			then
				tempthreat = floor((GetThreatValue("player", "targettarget") / GetThreatValue("targettargettarget", "targettarget")) * 100)
				LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.blue, tempthreat )
			end
		else if status == 2
		then
			threatdiff = (100 - nextThreat)
			LDBThreat.text = string.format("|c%sWEAK AGGRO: %d %% Lead.|r", Color.yellow, threatdiff )
			if threatvalue < 0
			then
				LDBThreat.text = string.format("|c%sWEAK AGGRO: %d %% Lead.|r", Color.blue, threatdiff )
			end
			if nextThreat == 0
			then
				LDBThreat.text = string.format("|c%s** WEAK AGGRO! **|r", Color.yellow )
				if threatvalue < 0
				then
					LDBThreat.text = string.format("|c%s** WEAK AGGRO! **|r", Color.blue )
				end
			end	
		else if status == 3
		then
			threatdiff = (100 - nextThreat)
			LDBThreat.text = string.format("|c%sAGGRO: %d %% Lead.|r", Color.red, threatdiff )
			if nextThreat == 0
			then
				LDBThreat.text = string.format("|c%s** AGGRO! **|r", Color.red )
				if threatvalue < 0
				then
					LDBThreat.text = string.format("|c%s** AGGRO! **|r", Color.blue )
				end
			end
		end
		end
		end
		end
		end
	end
end)

function LDBThreat:OnTooltipShow()
	self:AddLine("LDB-|cffffffffThreat|r |cff00ff00v3.2.01|r")
end
